#include "mylist.h"
/*
 *  Name       : mylist.h
 *  Author     : Andreas Romeyke
 *  Subject    : Projekt Informatik S99/1 2000
 *  Teammembers: Andreas Romeyke, Michael Schreiter, Dirk Baumann, Falko Gittel
 *  Copyright  : GPL (see http://www.gnu.org)
 *  Description: Eine Klasse, die eine Liste fr die Verwaltung der Postfaecher
 *               implementiert.
 *  Interfaces : see Source
 *  Tested     : egcs 2.91.66 under Linux; Borland C++ 5.02 under Windows 95
 *  Status     : very well tested.
 *  Date       : 11.05.2000
 */

/* in main-programm its necessary to include the next lines:
 * #include "postfach.h"
 */


//#define LDEBUG /* schaltet Debuggingmeldungen ein */

/* Funktionsbersicht (fr typen sh. Quelltext):
 *
 *	push_back : fgt Element hinten an Liste an
 *	push_front: fgt Element vorne an Liste an
 *	pop_back  : entfernt Element hinten von Liste
 *	pop_front : entfernt Element vorne von Liste
 *	del       : lscht Element an aktueller Position
 *	get       : gibt Element an aktueller Position zurck
 *	tofirst   : setze Position an Anfang
 *	tolast    : setze Position ans Ende
 *	size      : gibt Anzahl der Elemente in Liste zurck
 *	isfirst   : testet ob Position am Anfang
 *	islast    : testet ob Position am Ende
 *	isempty   : testet ob Liste leer
 *	next      : geht von Position aus eine weiter und gibt Element zurck
 *	prev      : geht von Position aus eine zurck und gibt Element zurck
 *
 */
inline list::list () { //Konstruktor
	first=NULL;
	last=NULL;
	index=NULL;
	lsize=0;
	empty=true;
#ifdef LDEBUG
	cerr << "list::constructor"<<endl;
#endif
#ifdef DEBUG
	cerr << "list::constructor"<<endl;
#endif
    }
inline bool list::push_back (LISTTYPE cont) { // hinten anfgen
	struct node * newp;
	newp=new node;
	if (newp==NULL) {
	    cerr << "Kein Speicher fr Listenelement verfgbar"<<endl;
	    exit(1);
	}
#ifdef LDEBUG
	cerr << "pointer (push_back):"<<newp<<endl;
#endif
	newp->prev=last;
	newp->next=NULL;
	newp->cont=cont;
	if (lsize==0) first=newp; //wenn 1. Element in Liste
	else last->next=newp;
	last=newp;
	index=newp;
	lsize++;
	empty=false;
	return (true);
    }
inline bool list::push_front (LISTTYPE cont) { // vorne anfgen
	struct node * newp;
	newp=new node;
	if (newp==NULL) {
	    cerr << "Kein Speicher fr Listenelement verfgbar"<<endl;
	    exit(1);
	}
#ifdef LDEBUG
	cerr << "pointer (push_front):"<<newp<<endl;
#endif
	newp->prev=NULL;
	newp->next=first;
	newp->cont=cont;
	first=newp;
	if (lsize==0) last=newp; //wenn 1. Element in Liste
	else first->prev=newp;
	index=newp;
	lsize++;
	empty=false;
	return(true);
    }
inline LISTTYPE list::pop_back () { //hinten wegnehmen
	struct node * newp;
	LISTTYPE ret;
	if ((empty==false)&&(last!=NULL)) {
	    if (lsize==1) {
		lsize=0;
         	last=NULL;
         	first=NULL;
		index=NULL;
		empty=true;
		newp=NULL;
		return (NULL);
	    }
      	    else {
		newp=last->prev;

#ifdef LDEBUG
		cerr << "pointer (pop_back):"<<newp<<endl;
#endif
      		newp->next=NULL;
      		index=newp;
      		lsize--;
      		empty=false;
		cerr << "last:"<<last<<";index"<<index<<endl;
		ret=last->cont;
		delete last;
		last=newp;
		return (ret);
	    }	
	}
	else return(NULL);
    }
inline LISTTYPE list::del() { //lscht Eintrag an aktueller Position
	struct node * newp;
	LISTTYPE ret;
	if (empty==false) {
	    if (lsize==1) {
		lsize=0;
		last=NULL;
		first=NULL;
		index=NULL;
		empty=true;
		ret=NULL;
	    }
	    else {
		newp=index->prev;
		if (newp!=NULL) newp->next=index->next;
		else first=index->next;
		newp=index->next;
		if (newp!=NULL) newp->prev=index->prev;
		else last=index->prev;
		ret=index->cont;
	        delete index;
		index=newp;
		lsize--;
		empty=false;
	    }
	    return(ret);

	}
	else return(NULL);    
    }
inline LISTTYPE list::pop_front () { //vorne wegnehmen
	struct node * newp;
	LISTTYPE ret;
	if ((empty==false)&&(last!=NULL)) {
	    if (lsize==1) {
		lsize=0;
		last=NULL;
		first=NULL;
		index=NULL;
		empty=true;
		newp=NULL;
		return (NULL);
	    }
	    else {
		newp=first->next;
#ifdef LDEBUG
		cerr << "pointer (pop_front):"<<newp<<endl;
#endif
		newp->prev=NULL;
		index=newp;
		lsize--;
		empty=false;
		ret=first->cont;
		delete first;
		first=newp;
		return (ret);
	    }
	}
	else return(NULL);
    }
inline bool list::tofirst () { //setze index auf 1. Element
	index=first;
	return(true);
    }
inline bool list::tolast () { //setze Index auf letztes Element
	index=last;
	return(true);
    }
    inline bool list::isfirst() { //ist Index 1. Element?
	if ((index!=NULL)&&(index->prev==NULL))
	    return(true);
	else
	    return (false);    
    }
    inline bool list::islast() { //ist Index letztes Element?
	if ((index!=NULL)&&(index->next==NULL))
	    return(true);
	else
	    return (false);    
    }
    inline  LISTTYPE list::get() {
	return(index->cont);
    }
    inline  LISTTYPE list::next() {
	node * newp;
	if (index!=NULL) {
	    newp=index->next;
	    index=newp;	
	    if (newp!=NULL) return(newp->cont);
	    else return (NULL);
	}
	else return(NULL);
    }
    inline  LISTTYPE list::prev() {
	node * newp;
	if (index!=NULL) {
	    newp=index->prev;
	    index=newp;
	    if (newp!=NULL) return(newp->cont);
	    else return (NULL);
	}
	else return(NULL);
    }
    inline unsigned long list::size () { //gibt Anzahl der Elemente der Liste zurck
	return(lsize);
    }
    inline bool list::isempty () { //gibt zurck, ob Liste leer ist, oder nicht
	return(empty);
    }
    inline list::~list () {
#ifdef DEBUG
	cerr<<"list::destruktor"<<endl;
#endif    
    }
