#ifndef MY_LIST_H
#define MY_LIST_H

/*
 *  Name       : mylist.h
 *  Author     : Andreas Romeyke
 *  Subject    : Projekt Informatik S99/1 2000
 *  Teammembers: Andreas Romeyke, Michael Schreiter, Dirk Baumann, Falko Gittel
 *  Copyright  : GPL (see http://www.gnu.org)
 *  Description: Eine Klasse, die eine Liste fr die Verwaltung der Postfaecher
 *               implementiert.
 *  Interfaces : see Source
 *  Tested     : egcs 2.91.66 under Linux; Borland C++ 5.02 under Windows 95
 *  Status     : very well tested.
 *  Date       : 11.05.2000
 */

#define LISTTYPE postfach *	/* MACRO definiert "container", */
				/* also was in Liste gespeichert wird */

/* in main-programm its necessary to include the next lines:
 * #include "postfach.h"
 */


//#define LDEBUG /* schaltet Debuggingmeldungen ein */

/* Funktionsbersicht (fr typen sh. Quelltext):
 *
 *	push_back : fgt Element hinten an Liste an
 *	push_front: fgt Element vorne an Liste an
 *	pop_back  : entfernt Element hinten von Liste
 *	pop_front : entfernt Element vorne von Liste
 *	del       : lscht Element an aktueller Position
 *	get       : gibt Element an aktueller Position zurck
 *	tofirst   : setze Position an Anfang
 *	tolast    : setze Position ans Ende
 *	size      : gibt Anzahl der Elemente in Liste zurck
 *	isfirst   : testet ob Position am Anfang
 *	islast    : testet ob Position am Ende
 *	isempty   : testet ob Liste leer
 *	next      : geht von Position aus eine weiter und gibt Element zurck
 *	prev      : geht von Position aus eine zurck und gibt Element zurck
 *
 */

class list {
    private:
	struct node {
      	    LISTTYPE cont;
    	    struct node *prev, *next;
	};
        struct node * first;
        struct node *last;
        struct node * index;
        unsigned long int lsize;
        bool empty;
    public:
	list (); //Konstruktor
	bool push_back (LISTTYPE cont);
	bool push_front (LISTTYPE cont);
	LISTTYPE pop_back ();
	LISTTYPE del();
	LISTTYPE pop_front ();
	bool tofirst ();
	bool tolast ();
	bool isfirst();
	bool islast();
	LISTTYPE get();
	LISTTYPE next();
	LISTTYPE prev();
	unsigned long size ();
	bool isempty ();
	~list ();
};
#endif
